diff -Naur a/COPYING b/COPYING
--- a/COPYING	2009-03-16 09:45:54.000000000 -0500
+++ b/COPYING	2014-11-26 14:14:02.723012591 -0600
@@ -2,7 +2,7 @@
 		       Version 2, June 1991
 
  Copyright (C) 1989, 1991 Free Software Foundation, Inc.
-                       59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+                       51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
  Everyone is permitted to copy and distribute verbatim copies
  of this license document, but changing it is not allowed.
 
diff -Naur a/rdiff_backup/backup.py b/rdiff_backup/backup.py
--- a/rdiff_backup/backup.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/backup.py	2014-11-26 14:11:23.831006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """High level functions for mirroring and mirror+incrementing"""
diff -Naur a/rdiff_backup/compare.py b/rdiff_backup/compare.py
--- a/rdiff_backup/compare.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/compare.py	2014-11-26 14:11:23.831006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Perform various kinds of comparisons.
diff -Naur a/rdiff_backup/connection.py b/rdiff_backup/connection.py
--- a/rdiff_backup/connection.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/connection.py	2014-11-26 14:11:23.835006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Support code for remote execution and data transfer"""
diff -Naur a/rdiff_backup/eas_acls.py b/rdiff_backup/eas_acls.py
--- a/rdiff_backup/eas_acls.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/eas_acls.py	2014-11-26 14:11:23.835006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Store and retrieve extended attributes and access control lists
diff -Naur a/rdiff_backup/FilenameMapping.py b/rdiff_backup/FilenameMapping.py
--- a/rdiff_backup/FilenameMapping.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/FilenameMapping.py	2014-11-26 14:11:23.839006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Coordinate corresponding files with different names
diff -Naur a/rdiff_backup/fs_abilities.py b/rdiff_backup/fs_abilities.py
--- a/rdiff_backup/fs_abilities.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/fs_abilities.py	2014-11-26 14:11:23.843006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Determine the capabilities of given file system
diff -Naur a/rdiff_backup/Globals.py b/rdiff_backup/Globals.py
--- a/rdiff_backup/Globals.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/Globals.py	2014-11-26 14:11:23.843006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Hold a variety of constants usually set at initialization."""
diff -Naur a/rdiff_backup/Hardlink.py b/rdiff_backup/Hardlink.py
--- a/rdiff_backup/Hardlink.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/Hardlink.py	2014-11-26 14:11:23.847006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Preserve and restore hard links
diff -Naur a/rdiff_backup/hash.py b/rdiff_backup/hash.py
--- a/rdiff_backup/hash.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/hash.py	2014-11-26 14:11:23.847006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Contains a file wrapper that returns a hash on close"""
diff -Naur a/rdiff_backup/increment.py b/rdiff_backup/increment.py
--- a/rdiff_backup/increment.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/increment.py	2014-11-26 14:11:23.847006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Provides functions and *ITR classes, for writing increment files"""
diff -Naur a/rdiff_backup/iterfile.py b/rdiff_backup/iterfile.py
--- a/rdiff_backup/iterfile.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/iterfile.py	2014-11-26 14:11:23.851006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Convert an iterator to a file object and vice-versa"""
diff -Naur a/rdiff_backup/lazy.py b/rdiff_backup/lazy.py
--- a/rdiff_backup/lazy.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/lazy.py	2014-11-26 14:11:23.851006038 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Define some lazy data structures and functions acting on them"""
diff -Naur a/rdiff_backup/librsync.py b/rdiff_backup/librsync.py
--- a/rdiff_backup/librsync.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/librsync.py	2014-11-26 14:11:23.855006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Provides a high-level interface to some librsync functions
diff -Naur a/rdiff_backup/log.py b/rdiff_backup/log.py
--- a/rdiff_backup/log.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/log.py	2014-11-26 14:11:23.855006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Manage logging, displaying and recording messages with required verbosity"""
diff -Naur a/rdiff_backup/longname.py b/rdiff_backup/longname.py
--- a/rdiff_backup/longname.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/longname.py	2014-11-26 14:11:23.859006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Handle long filenames
diff -Naur a/rdiff_backup/Main.py b/rdiff_backup/Main.py
--- a/rdiff_backup/Main.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/Main.py	2014-11-26 14:11:23.859006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Start (and end) here - read arguments, set global settings, etc."""
diff -Naur a/rdiff_backup/manage.py b/rdiff_backup/manage.py
--- a/rdiff_backup/manage.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/manage.py	2014-11-26 14:11:23.863006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """list, delete, and otherwise manage increments"""
diff -Naur a/rdiff_backup/metadata.py b/rdiff_backup/metadata.py
--- a/rdiff_backup/metadata.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/metadata.py	2014-11-26 14:11:23.867006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Store and retrieve metadata in destination directory
diff -Naur a/rdiff_backup/Rdiff.py b/rdiff_backup/Rdiff.py
--- a/rdiff_backup/Rdiff.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/Rdiff.py	2014-11-26 14:11:23.867006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Invoke rdiff utility to make signatures, deltas, or patch"""
diff -Naur a/rdiff_backup/regress.py b/rdiff_backup/regress.py
--- a/rdiff_backup/regress.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/regress.py	2014-11-26 14:11:23.867006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Code for reverting the rdiff-backup directory to prev state
diff -Naur a/rdiff_backup/restore.py b/rdiff_backup/restore.py
--- a/rdiff_backup/restore.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/restore.py	2014-11-26 14:11:23.871006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Read increment files and restore to original"""
diff -Naur a/rdiff_backup/robust.py b/rdiff_backup/robust.py
--- a/rdiff_backup/robust.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/robust.py	2014-11-26 14:11:23.875006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Catch various exceptions given system call"""
diff -Naur a/rdiff_backup/rorpiter.py b/rdiff_backup/rorpiter.py
--- a/rdiff_backup/rorpiter.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/rorpiter.py	2014-11-26 14:11:23.875006039 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Operations on Iterators of Read Only Remote Paths
diff -Naur a/rdiff_backup/rpath.py b/rdiff_backup/rpath.py
--- a/rdiff_backup/rpath.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/rpath.py	2014-11-26 14:11:23.879006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Wrapper class around a real path like "/usr/bin/env"
diff -Naur a/rdiff_backup/Security.py b/rdiff_backup/Security.py
--- a/rdiff_backup/Security.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/Security.py	2014-11-26 14:11:23.879006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Functions to make sure remote requests are kosher"""
diff -Naur a/rdiff_backup/selection.py b/rdiff_backup/selection.py
--- a/rdiff_backup/selection.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/selection.py	2014-11-26 14:11:23.883006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Iterate exactly the requested files in a directory
diff -Naur a/rdiff_backup/SetConnections.py b/rdiff_backup/SetConnections.py
--- a/rdiff_backup/SetConnections.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/SetConnections.py	2014-11-26 14:11:23.887006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Parse args and setup connections
diff -Naur a/rdiff_backup/static.py b/rdiff_backup/static.py
--- a/rdiff_backup/static.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/static.py	2014-11-26 14:11:23.887006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """MakeStatic and MakeClass
diff -Naur a/rdiff_backup/statistics.py b/rdiff_backup/statistics.py
--- a/rdiff_backup/statistics.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/statistics.py	2014-11-26 14:11:23.887006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Generate and process aggregated backup information"""
diff -Naur a/rdiff_backup/TempFile.py b/rdiff_backup/TempFile.py
--- a/rdiff_backup/TempFile.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/TempFile.py	2014-11-26 14:11:23.891006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Manage temp files
diff -Naur a/rdiff_backup/Time.py b/rdiff_backup/Time.py
--- a/rdiff_backup/Time.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/Time.py	2014-11-26 14:11:23.891006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """Provide time related exceptions and functions"""
diff -Naur a/rdiff_backup/user_group.py b/rdiff_backup/user_group.py
--- a/rdiff_backup/user_group.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/user_group.py	2014-11-26 14:11:23.895006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 """This module deal with users and groups
diff -Naur a/rdiff_backup/win_acls.py b/rdiff_backup/win_acls.py
--- a/rdiff_backup/win_acls.py	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff_backup/win_acls.py	2014-11-26 14:11:23.895006040 -0600
@@ -14,7 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 from __future__ import generators
diff -Naur a/rdiff-backup b/rdiff-backup
--- a/rdiff-backup	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff-backup	2014-11-26 14:11:23.815006037 -0600
@@ -6,7 +6,7 @@
 # This program is licensed under the GNU General Public License (GPL).
 # you can redistribute it and/or modify it under the terms of the GNU
 # General Public License as published by the Free Software Foundation,
-# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA; either
+# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA; either
 # version 2 of the License, or (at your option) any later version.
 # Distributions of rdiff-backup should include a copy of the GPL in a
 # file called COPYING.  The GPL is also available online at
diff -Naur a/rdiff-backup-statistics b/rdiff-backup-statistics
--- a/rdiff-backup-statistics	2009-03-16 09:45:54.000000000 -0500
+++ b/rdiff-backup-statistics	2014-11-26 14:11:23.815006037 -0600
@@ -17,7 +17,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with rdiff-backup; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
 # USA
 
 import os, sys, re, getopt